package com.cirmuller.maidaddition.capability;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.cirmuller.maidaddition.api.IChunkLoadingCapability;
import com.cirmuller.maidaddition.tickets.TicketRegistry;
import com.github.tartaricacid.touhoulittlemaid.entity.passive.EntityMaid;
import java.util.LinkedList;
import java.util.List;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.util.Unit;
import net.minecraft.world.level.ChunkPos;
import net.minecraft.world.level.Level;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class ChunkLoadingCapability implements IChunkLoadingCapability {
  public static Logger logger = LogManager.getLogger("maidaddition");
  
  EntityMaid maid;
  
  public ChunkLoadingCapability(EntityMaid maid) {
    this.maid = maid;
  }
  
  public EntityMaid getMaid() {
    return this.maid;
  }
  
  public void updateChunkLoading(int radius) {
    List<ChunkPos> currentToLoad = new LinkedList<>();
    ChunkPos maidOn = new ChunkPos(this.maid.m_20097_());
    for (int i = -radius; i <= radius; i++) {
      for (int j = -radius; j <= radius; j++)
        currentToLoad.add(new ChunkPos(maidOn.f_45578_ + i, maidOn.f_45579_ + j)); 
    } 
    for (ChunkPos pos : currentToLoad) {
      Level level = this.maid.m_9236_();
      if (level instanceof ServerLevel) {
        ServerLevel serverLevel = (ServerLevel)level;
        serverLevel.m_7726_().addRegionTicket(TicketRegistry.MAID_TICKET, pos, 2, Unit.INSTANCE, true);
      } 
    } 
  }
}
